
/********  19-APR-2013****/ 

#pragma config OSC = HS,OSCS = OFF
#pragma config PWRT = OFF
#pragma config WDT = OFF
#pragma config DEBUG = OFF,LVP = OFF ,STVR = OFF

#include <P18F452.h>                    // USING 12MHZ CLOCK
#include<stdio.h>
#include<string.h>

#define output       LATBbits.LATB7
#define output_pin   TRISBbits.TRISB7=0
#define output_low   LATBbits.LATB7=0
#define output_high  LATBbits.LATB7=1
#define input_pin    TRISBbits.TRISB7=1
#define OW_PIN       PORTBbits.RB7


typedef unsigned char bool;
typedef unsigned char uint8;


//bool ibit,temp;
char str[80];
//unsigned char Rom_Addr[8];

void DS1820_DelaySw60us(void);
void DS1820_DelaySw240us(void);
void DS1820_DelaySwReset(void);
void  DS1820_DelayCro(unsigned char val);

void DS1820_DelayUs(int val);
void DS1820_Reset(void);
void ReadDS1820ROM(void);
void DS1820_WriteByte(uint8 val_u8);
uint8 DS1820_ReadByte(void); 


void SerTx(unsigned char c);
void SerTxS(char* s);


bool input_func(void)
{
    TRISBbits.TRISB7 = 1;     
    return (PORTBbits.RB7);
}

void main()
{
int r;
uint8 n;

        TXSTA = 0x20;  					     //  for asynchronous , tx enable settings
        SPBRG = 18;  						// for 12mhz baud rate.
        TXSTAbits.TXEN = 1;
	    RCSTAbits.SPEN = 1;

DS1820_DelayUs(10000);
DS1820_Reset();
for(n=0;n<82;n++); 
ReadDS1820ROM();
DS1820_DelayUs(10000);

for(r=0;r<10;r++)
DS1820_DelayUs(10000);


}
 

/****************************************************/

void DS1820_Reset()
{
int brs,rst,ars,aars;

brs=input_func();
output_pin;
output_low;
DS1820_DelaySwReset();
input_pin;
DS1820_DelaySw60us();
rst=PORTBbits.RB7;
ars = input_func();
DS1820_DelaySw240us();
aars = input_func();
sprintf(str, " breset=%1d rest= %1d  afres %1d   afafrs= %1d   ",brs,rst,ars,aars);  //
        SerTxS(str);
   
}

/****************************************************/


void ReadDS1820ROM(void)
{
 int n;
 int dat[9];
 sprintf(str," Addr =");
 SerTxS(str);
 output_pin;
 output_low;
 DS1820_DelaySwReset();
 DS1820_DelaySw60us();
 DS1820_DelaySw240us();
 input_pin;
 for(n=0;n<100;n++);  // remaining 410usec


 DS1820_WriteByte(0x33);  // readrom command


 for(n=0;n<8;n++) 
 {
 dat[n]= 0;     
 dat[n]=DS1820_ReadByte();
 }
   DS1820_DelayUs(500); 
 for(n=7;n>=0;n--)
{ 
 sprintf(str," %02x ",dat[n]);
 SerTxS(str);
}   
}

/****************************************************/



void SerTx(unsigned char c)
{
	while(PIR1bits.TXIF == 0);  
	TXREG = c;                  // 1 inst
}

void SerTxS(char* s)
{
   int i;  
   for(i=0; i<strlen(s); i++)   
   SerTx(s[i]);                // 7 inst
   
}

void DS1820_DelayUs(int val)
{
int k;
for(k=0;k<val;k++); 
}
  

void DS1820_DelaySw60us(void)
{
int i;
for(i=0;i<12;i++);  
}


void DS1820_DelaySwReset(void)
{
int j;
for(j=0;j<96;j++);
}

void DS1820_DelaySw240us(void)
{
int k;
for(k=0;k<48;k++);
}
/*************************************/

void DS1820_WriteByte(uint8 val_u8)
{
char i,j,temp;
   
    
    for (i=0;i<8;i++)
    {
     output_pin;
     temp = val_u8 & 0x01;
     if (temp){
     OW_PIN=0;
     ; 
     input_pin;
     for(j=0;j<2;j++);
     for(j=0;j<3;j++);
              }

     else     {
               output_pin;
               OW_PIN=0;
               DS1820_DelayCro(1);
               for(j=0;j<1;j++);
               input_pin;
              }
     val_u8 = val_u8 >>1;
   
     }
}


/********************************/

uint8 DS1820_ReadByte(void)
{
unsigned char i,j;
   unsigned char data=0;
   
   for(j=0;j<8;j++)
   {

        output_low;
        output_pin;;
        for(i=0;i<1;i++);
        i=2;
        i=3;
        input_pin;
        i=5;
        i=6;
        i=7;
        data = (OW_PIN << j) | data;
        for(i=0;i<5;i++); 
               
   }
   
   return data;
}


void  DS1820_DelayCro(unsigned char val)
{
   int i,j;
   for(i = 0; i < val; i++)
   for( j = 0; j < 3; j++);
} 





/****************Good Out Put***************
Addr =93 00 08 00 c4 37 2d 10 breset=1 r
est= 0  afres 0   afafrs= 1    Addr =93 00 08 00 c4 37 2d 10 breset=1 rest= 0  a
fres 0   afafrs= 1    Addr =93 00 08 00 c4 37 2d 10 breset=1 rest= 0  afres 0
afafrs= 1    Addr =93 00 08 00 c4 37 2d 10 breset=1 rest= 0  afres 0   afafrs= 1
    

	
Addr =d8 00 08 00 c4 0f ef 10 breset=1 rest= 0  afres 0   afafrs= 1    Addr
=d8 00 08 00 c4 0f ef 10 breset=1 rest= 0  afres 0   afafrs= 1    Addr =d8 00 08
 00 c4 0f ef 10 breset=1 rest= 0  afres 0   afafrs= 1    Addr =d8 00 08 00 c4 0f
 ef 10 breset=1 rest= 0  afres 0   afafrs= 1    




   
*/
